package cz.muni.fi.pa165.rest.controllers;
 
import cz.muni.fi.pa165.rest.data.CustomerNotFoundException;
import cz.muni.fi.pa165.rest.data.CustomerResource;
import cz.muni.fi.pa165.rest.service.CustomersService;
import java.net.URI;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;
 
/**
 * Our REST controller
 *
 */
// TODO Add annotations to map the class as a REST controller
public class CustomersController {
 
    @Autowired
    private CustomersService customersService;
 
   
    /**
     * Get the list of customers in plain text
     * 
     */
    // TODO add the request mapping with method and accept header
    public String getCustomers() {
        
        // TODO implementation
        return "";
    }
 
    /**
     * Get one Customer in XML representation
     * 
     */
    // TODO add the request mapping with method and accept header and pathvariable
    public void getCustomerXML( Integer id) {
        // TODO implementation
    }
    
    /**
     * Get the one customer
     * 
     */ 
    // TODO add the request mapping with method and accept header and pathvariable
    public void getCustomer(Integer id) {
        // TODO implementation
    }
    
    

    /**
     * Get one CustomerResource in JSON representation
     */
    // TODO add the request mapping with method and accept header and pathvariable
    public void getCustomerAsJSON( Integer id) {
        // TODO implementation
    }
    
    
    
    /**
     * Get the count of CustomerResources
     *  
     */    
       // TODO add the request mapping with method and accept header and pathvariable
     public void getCount() {
        // TODO implementation
    }
    
    
    /**
     * 
     * POST a new  Customer in JSON format
     */
    // TODO add the request mapping with method and mime type consumed, generally post should be mapped to 
     // the root category, e.g. /customers if I want to add a new customer
     // note you need to annotate the CustomerResource paramether with @RequestBody for serialization to work
     // Look at ResponseEntity and ServletUriComponentsBuilder to return the uri for the newly created resource
     // You can use ResponseEntity constructor to return body, headers and status codes, e.g.
     // ResponseEntity<String>("response body", null, HttpStatus.CREATED)
       public void postJson(CustomerResource customerResource) {

        // TODO implementation
    }
    
    /**
     *  PUT a new Customer in JSON format
     *
     */
       // TODO add the request mapping with method and mime type consumed
       // you can map it to "{id}" and pathvariable
       // remember to annotate the CustomerResource parameter with @RequestBody
       // for serialization to work
       // in case the id is not present in the list of customers, 
       // this method should throw a CustomerNotFoundException exception
       // (you need to annotate the exception class to return 404)
    public void putJson(Integer id, CustomerResource customerResource) {
    }
    
    
    /**
     * DELETE one customer
     * 
     * @param id 
     */
       // TODO add the request mapping with method path variable
       // in case the id is not present in the list of customers, 
       // this method should throw a CustomerNotFoundException exception
       // (you need to annotate the exception class to return 404)
     public void delete(Integer id) {
  
    }
    
}